package jiaowuxitong

import (
	"reflect"
	"strings"

	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaowuxitong/model"
	"shylinux.com/x/mysql-story/src/db"
	_ "shylinux.com/x/mysql-story/src/db/mysql"
)

type Table struct {
	db.Table
	create string `name:"create name*"`
}

func (s Table) Init(m *ice.Message, arg ...string) {
	kit.If(m.Config(web.PORTAL) == ice.TRUE, func() { m.GoSleep("30ms", func() { portal{}.Show(m) }) })
}
func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.USER_UID, model.CLASS_UID, model.SCHOOL_UID:
		m.Optionv(mdb.SELECT, model.UID, model.NAME)
		m.Cmdy(m.Prefix(strings.TrimSuffix(arg[0], "_uid"))).RenameAppend(model.UID, arg[0])
	case GRADE:
		y := kit.Int(kit.Split(m.Time(), "-")[0])
		for i := 0; i < 10; i++ {
			m.Push(arg[0], kit.Format("%d级", y))
			y--
		}
	}
}
func (s Table) LeftJoin(target ice.Any) string {
	model, models := "", ""
	switch target := target.(type) {
	case string:
		model = target
	default:
		model = kit.LowerCapital(kit.Select("", kit.Split(reflect.TypeOf(target).String(), "."), -1))
	}
	if kit.HasSuffix(model, "s") {
		models = model + "es"
	} else {
		models = model + "s"
	}
	return kit.Format("left join %s on %s_uid = %s.uid", models, model, models)
}

func prefixKey() string { return kit.Keys("web.team", kit.PathName(-1), kit.FileName(-1)) }
