package model

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/mysql-story/src/db"
)

const (
	UID         = "uid"
	NAME        = "name"
	USER_UID    = "user_uid"
	USER_NAME   = "user_name"
	CLASS_UID   = "class_uid"
	CLASS_NAME  = "class_name"
	SCHOOL_UID  = "school_uid"
	SCHOOL_NAME = "school_name"
)

type User struct {
	db.ModelWithUID
	Name string `gorm:"type:char(32)"`
}
type UserClass struct {
	db.Model
	UserUID  string `gorm:"type:char(32);index"`
	ClassUID string `gorm:"type:char(32)"`
}
type Class struct {
	db.ModelWithUID
	SchoolUID string `gorm:"type:char(32)"`
	Grade     string `gorm:"type:char(32)"`
	Name      string `gorm:"type:varchar(256)"`
}
type School struct {
	db.ModelWithUID
	Name    string `gorm:"type:varchar(256)"`
	Address string `gorm:"type:varchar(4096)"`
	Info    string
}
type Homework struct {
	db.ModelWithUID
	ClassUID string `gorm:"type:char(32);index"`
	Content  string
}

type models struct{ db.Models }

func (s models) Init(m *ice.Message, arg ...string) {
	s.Models.Register(m, &User{}, &UserClass{}, &Class{}, &School{}, &Homework{})
}

func init() { ice.Cmd("web.team.education.jiaowuxitong.models", models{}) }
