package jiaowuxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/aaa"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaowuxitong/model"
)

type portal struct {
	ice.Hash
	Class       Class
	userClass   userClass
	export      string `data:"true"`
	short       string `data:"index"`
	field       string `data:"time,name,icons,index,order,enable"`
	list        string `name:"list class_uid index uid auto" role:"void"`
	classCreate string `name:"classCreate school_uid* grade* name*" role:"void"`
}

func (s portal) Inputs(m *ice.Message, arg ...string) {
	s.Class.Inputs(m, arg...)
}
func (s portal) List(m *ice.Message, arg ...string) {
	if m.Display(""); m.Option(model.USER_UID) == "" {
		m.EchoInfoButton("please login", aaa.LOGIN)
	} else if len(arg) == 0 {
		m.Cmdy(s.userClass, s.userClass.MyClass, m.Option(model.USER_UID)).Action(s.ClassCreate, aaa.LOGIN).PushAction(s.ClassRemove)
		kit.If(m.Length() == 0, func() { m.EchoInfoButton("please create class") })
		m.StatusTimeCount(m.OptionSimple(model.USER_UID))
	} else if len(arg) == 1 {
		s.Hash.List(m, arg[1:]...).SortInt(mdb.ORDER)
	} else if len(arg) == 2 {
		m.Cmdy(arg[1]).PushAction().Action()
	} else {
		m.FieldsSetDetail()
		m.Cmdy(arg[1], mdb.SELECT, "uid = ?", arg[2]).PushAction().Action()
	}
}
func (s portal) ClassCreate(m *ice.Message, arg ...string) {
	if !m.Cmdy(s.Class, s.Class.Create, arg).IsErr() {
		m.Cmdy(s.userClass, s.userClass.Create, m.OptionSimple(model.USER_UID), model.CLASS_UID, m.Result())
	}
}
func (s portal) ClassRemove(m *ice.Message, arg ...string) {
	if !m.Cmdy(s.Class, s.Class.Remove, arg).IsErr() {
		m.Cmdy(s.userClass, s.userClass.Remove, m.OptionSimple(model.USER_UID), model.CLASS_UID, m.Result())
	}
}

func init() { ice.TeamCtxCmd(portal{}) }

func (s portal) Show(m *ice.Message, arg ...string) {
	cmd := m.GetCommand()
	m.Cmd(s, s.Create, mdb.NAME, cmd.Help, mdb.ICONS, cmd.Icon, ctx.INDEX, m.PrefixKey())
}
